USE COWS
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

IF	OBJECT_ID(N'tempdb..#CUST_INFO_SENSITIVE_ALL', N'U') IS NOT NULL 
			DROP TABLE #CUST_INFO_SENSITIVE_ALL

DECLARE @H5CustID Table (CustID Int, Flag Bit)

Insert into @H5CustID
Select DISTINCT h5.CUST_ID, 0
	FROM	dbo.ORDR odr WITH (NOLOCK) 
			Inner Join dbo.H5_FOLDR h5 WITH (NOLOCK) ON odr.H5_FOLDR_ID = h5.H5_FOLDR_ID
				WHERE odr.ORDR_CAT_ID IN (1,3,4,5)
					AND odr.SCURD_CD = 0
					AND h5.SCURD_CD IS NULL

DECLARE @CustTypes	Varchar(1000)
SELECT		@CustTypes	=	COALESCE(@CustTypes + ',' + '''''' + SENS_DATA_TYPE_CD + '''''', '''''' + SENS_DATA_TYPE_CD + '''''') 
				FROM	dbo.LK_L2P_SENS_DATA_TYPE	WITH (NOLOCK)
				WHERE	CNTCT_TYPE_ID IS NOT NULL
--SELECT @CustTypes
Select * From @H5CustID

CREATE TABLE #CUST_INFO_SENSITIVE_ALL
			(
				[CUST_CHARS_ID]			Int			NOT NULL,
				[SENS_DATA_TYPE_CD]		Varchar(4)	NOT NULL,
				[EFF_BEGIN_TMST]		DateTime	NOT NULL,
				[EFF_END_TMST]			DateTime	NOT NULL,
				[SCTY_GRP_CD]			Varchar(5)	NULL,
				[CNTRC_CD]				Varchar(3)	NOT NULL,
				[MSTR_CHARS_ID]			Int			NOT NULL,
				[SENS_NME]				Varchar(50) NULL,
				[TITLE_TXT]				Varchar(30) NULL,
				[LINE_1_ADR]			Varchar(26) NULL,
				[LINE_2_ADR]			Varchar(26) NULL,
				[CTY_NME]				Varchar(20) NULL,
				[STT_CD]				Varchar(2)	NULL,
				[PSTL_CD]				Varchar(15) NULL,
				[PROVINCE_CD]			Varchar(2)	NULL,
				[CTRY_CD]				Varchar(3)	NULL,
				[PHN_NBR]				Varchar(20) NULL,
				[PHN_EXT_NBR]			Varchar(4)	NULL,
				[EMAIL_ADR]				Varchar(60) NULL,
				[IPS_CYC_ID]			Varchar(2)	NULL,
				[IPS_RCVBL_TYPE_CD]		Varchar(1)	NULL,
				[SRVC_CD]				Varchar(3)	NULL,
				[RLAT_KEY_ID]			Varchar(50) NOT NULL,
				[ID_TYPE_CD]			Varchar(20) NOT NULL,
				[ID_TYPE_DES]			Varchar(50) NULL,
				[SCTY_GRP_DES]			Varchar(50) NULL,
				[SENS_DATA_TYPE_DES]	Varchar(30) NULL,
				[SENS_DATA_CAT_CD]		Varchar(4)	NULL,
				[SENS_DATA_CAT_DES]		Varchar(30)	NULL
			) 

DECLARE @ctr int = 0
DECLARE @Cnt int 
Select @Cnt = Count(1) From @H5CustID
DECLARE @H5 INT 
While @ctr < @Cnt
	BEGIN
		SELECT Top 1 @H5 = CustID
			From @H5CustID
			WHERE Flag = 0
			SELECT @H5
			EXEC('CALL SENS_CTX.SET_CONTEXT_FGAC('''+'QDA'+''', '''', '''')') AT L2S										

			DECLARE @CMD2 AS NVARCHAR(MAX)
			SET @CMD2 = 
				'INSERT INTO #CUST_INFO_SENSITIVE_ALL ' +
				'([CUST_CHARS_ID],[SENS_DATA_TYPE_CD],[EFF_BEGIN_TMST],[EFF_END_TMST],[SCTY_GRP_CD],[CNTRC_CD] ' +
				',[MSTR_CHARS_ID],[SENS_NME],[TITLE_TXT],[LINE_1_ADR],[LINE_2_ADR],[CTY_NME],[STT_CD],[PSTL_CD] ' +
				',[PROVINCE_CD],[CTRY_CD],[PHN_NBR],[PHN_EXT_NBR],[EMAIL_ADR],[IPS_CYC_ID],[IPS_RCVBL_TYPE_CD] ' +
				',[SRVC_CD],[RLAT_KEY_ID],[ID_TYPE_CD],[ID_TYPE_DES],[SCTY_GRP_DES],[SENS_DATA_TYPE_DES] ' +
				',[SENS_DATA_CAT_CD],[SENS_DATA_CAT_DES]) ' +
				'SELECT CUST_CHARS_ID,SENS_DATA_TYPE_CD,EFF_BEGIN_TMST,EFF_END_TMST,SCTY_GRP_CD,CNTRC_CD ' +
				',MSTR_CHARS_ID,SENS_NME,TITLE_TXT,LINE_1_ADR,LINE_2_ADR,CTY_NME,STT_CD,PSTL_CD ' +
				',PROVINCE_CD,ISO_CTRY_CD,PHN_NBR,PHN_EXT_NBR,EMAIL_ADR,IPS_CYC_ID,IPS_RCVBL_TYPE_CD ' +
				',SRVC_CD,RLAT_KEY_ID,ID_TYPE_CD,ID_TYPE_DES,SCTY_GRP_DES,SENS_DATA_TYPE_DES ' +
				',SENS_DATA_CAT_CD,SENS_DATA_CAT_DES ' +
				'FROM OPENQUERY ' +
						'(L2S, ' +
						'''select CUST_CHARS_ID,SENS_DATA_TYPE_CD,EFF_BEGIN_TMST,EFF_END_TMST,SCTY_GRP_CD,CNTRC_CD ' +
						',MSTR_CHARS_ID,SENS_NME,TITLE_TXT,LINE_1_ADR,LINE_2_ADR,CTY_NME,STT_CD,PSTL_CD ' +
						',PROVINCE_CD,ISO_CTRY_CD,PHN_NBR,PHN_EXT_NBR,EMAIL_ADR,IPS_CYC_ID,IPS_RCVBL_TYPE_CD ' +
						',SRVC_CD,RLAT_KEY_ID,ID_TYPE_CD,ID_TYPE_DES,SCTY_GRP_DES,SENS_DATA_TYPE_DES ' +
						',SENS_DATA_CAT_CD,SENS_DATA_CAT_DES from sens_owner.v_sens_adr S ' +
						'WHERE S.ID_TYPE_CD = ''''CIP_CUST_ID'''' AND S.EFF_END_TMST > to_date(''''12/31/3333'''', ''''mm/dd/yyyy'''') AND SRVC_CD IN (''''H5'''',''''ES'''') 
						AND S.RLAT_KEY_ID IN (' + CONVERT(VARCHAR, @H5)  + ') AND S.SENS_DATA_TYPE_CD IN (' + @CustTypes + ')'')'
			
			EXECUTE sp_executesql @CMD2
			EXEC('CALL SENS_CTX.CLEAR_CONTEXT_FGAC()') AT L2S
			--SELECT * From #CUST_INFO_SENSITIVE_ALL
			IF ((SELECT Count(1) From #CUST_INFO_SENSITIVE_ALL) > 0)
				BEGIN
					Update h5
						Set h5.SCURD_CD = 1
							, h5.CSG_LVL_CD = t.SCTY_GRP_CD
						From	dbo.H5_FOLDR h5 WITH (ROWLOCK)
					Inner Join	#CUST_INFO_SENSITIVE_ALL t WITH (NOLOCK) ON t.RLAT_KEY_ID = h5.CUST_ID
						WHERE	h5.SCURD_CD IS NULL

					Update odr
						Set odr.SCURD_CD = 1
							, odr.CSG_LVL_CD = t.SCTY_GRP_CD
						From	dbo.H5_FOLDR h5 WITH (NOLOCK)
					Inner Join	#CUST_INFO_SENSITIVE_ALL t WITH (NOLOCK) ON t.RLAT_KEY_ID = h5.CUST_ID
					Inner Join	dbo.ORDR odr WITH (ROWLOCK) ON odr.H5_FOLDR_ID = h5.H5_FOLDR_ID
						WHERE	odr.SCURD_CD = 0
							AND odr.ORDR_CAT_ID IN (1,3,4,5)
				END
		Delete from #CUST_INFO_SENSITIVE_ALL
		Update @H5CustID SET Flag = 1 WHERE CustID = @H5 AND Flag = 0
		SET @ctr = @ctr + 1
	END

Insert into dbo.ordr_nte (NTE_TYPE_ID,ORDR_ID,CREAT_DT,CREAT_BY_USER_ID,REC_STUS_ID,NTE_TXT,MODFD_BY_USER_ID,MODFD_DT)
Select 19,odr.ORDR_ID,GETDATE(),1,1,'H5 Customer ID: ' + CONVERT(VARCHAR,h5.CUST_ID) + ' security has been modified by L2P lookup.',NULL,NULL
	From @H5CustID th5 
Inner Join dbo.H5_FOLDR h5 WITH (NOLOCK) ON th5.CustID = h5.CUST_ID
Inner Join dbo.ORDR odr WITH (NOLOCK) ON odr.H5_FOLDR_ID = h5.H5_FOLDR_ID
	Where h5.SCURD_CD = 1
		AND odr.ORDR_CAT_ID IN (1,3,4,5)


--Select * From dbo.ORDR_NTE WITH (NOLOCK) WHERE NTE_TXT LIKE 'H5 Customer ID:%' ORDER BY NTE_ID DESC 		




--SELECT * FROM #CUST_INFO_SENSITIVE_ALL

--Select DISTINCT h5.CUST_ID
--	From	dbo.H5_FOLDR h5 WITH (NOLOCK)
--Inner Join	#CUST_INFO_SENSITIVE_ALL t WITH (NOLOCK) ON t.RLAT_KEY_ID = h5.CUST_ID
--	WHERE	h5.SCURD_CD IS NULL

--Select DISTINCT odr.ORDR_ID, odr.ORDR_CAT_ID, odr.SCURD_CD,h5.CUST_ID
--	From	dbo.H5_FOLDR h5 WITH (NOLOCK)
--Inner Join	#CUST_INFO_SENSITIVE_ALL t WITH (NOLOCK) ON t.RLAT_KEY_ID = h5.CUST_ID
--Inner Join	dbo.ORDR odr WITH (NOLOCK) ON odr.H5_FOLDR_ID = h5.H5_FOLDR_ID
--	WHERE	h5.SCURD_CD IS NULL
--		AND odr.SCURD_CD = 0
--		AND odr.ORDR_CAT_ID IN (1,3,4,5)
--Update h5 
--	Set		h5.SCURD_CD = 1,
--			h5.CSG_LVL_CD = ''
--	From	dbo.H5_FOLDR h5 WITH (ROWLOCK)
--Inner Join	#CUST_INFO_SENSITIVE_ALL t WITH (NOLOCK) ON t.RLAT_KEY_ID = h5.CUST_ID
--	WHERE	h5.SCURD_CD IS NULL

--Update	odr
--	SET		odr.SCURD_CD = 1
--			,odr.CSG_LVL_CD	=	h5.CSG_LVL_CD
--	From	dbo.ORDR odr WITH (ROWLOCK)
--Inner Join	dbo.H5_FOLDR h5 WITH (NOLOCK) ON odr.H5_FOLDR_ID = h5.H5_FOLDR_ID
--	Where	odr.SCURD_CD = 0
--		AND h5.SCURD_CD = 1
--		AND odr.ORDR_CAT_ID IN (1,3,4,5)

--Select * From dbo.LK_ORDR_CAT

